///////////////////////////////////////////////////////////////
// [eBeB֐Q
///////////////////////////////////////////////////////////////
// *.cpp łȂ *.h ɂR͓ɂ܂B

#pragma region VXe֘A

#include <cvver.h>

///////////////////////////////////////////////////////////////
// OpenCVCXg[ꂽtH_Ԃ܂B
static String^ GetOpenCVInstallDirectory()
{
#if (CV_MAJOR_VERSION == 2) && (CV_MINOR_VERSION == 0) && (CV_SUBMINOR_VERSION == 0)
	// for Ver 2.0

	// libcv200.dll
	WCHAR	findpath[ MAX_PATH + 1 ];
	WCHAR*	fptr = NULL;
	DWORD	rc;
	rc = SearchPath( NULL, L"libcv200.dll", NULL, sizeof(findpath)/sizeof(WCHAR), findpath, &fptr );
	if( rc == 0 )	throw gcnew System::Exception( "DLL܂B" );
	String^ dllpath = gcnew String( findpath );

	// DLLpX̐epX̐epX擾ic:\aaa\...\bbb\bin\cv100.dll -> c:\aaa...\bbbj
	System::IO::DirectoryInfo^ di = System::IO::Directory::GetParent( dllpath );
	String^ wp = di->Parent->FullName;
	
	return wp;

#elif (CV_MAJOR_VERSION == 1) && (CV_MINOR_VERSION == 1) && (CV_SUBMINOR_VERSION == 0)
	// for Ver 1.1pre

	// CV110.DLL
	WCHAR	findpath[ MAX_PATH + 1 ];
	WCHAR*	fptr = NULL;
	DWORD	rc;
	rc = SearchPath( NULL, L"cv110.dll", NULL, sizeof(findpath)/sizeof(WCHAR), findpath, &fptr );
	if( rc == 0 )		throw gcnew System::Exception( "DLL܂B" );
	String^ dllpath = gcnew String( findpath );

	// DLLpX̐epX̐epX擾ic:\aaa\...\bbb\bin\cv100.dll -> c:\aaa...\bbbj
	System::IO::DirectoryInfo^ di = System::IO::Directory::GetParent( dllpath );
	String^ wp = di->Parent->FullName;
	
	return wp;

#else

	// ݃[hĂ郂W[
	List<String^>^ lst = NWM_EnumerateLoadedModules();
	
	// "CV???.DLL"
	String^ ff = nullptr;
	for each(String^ fname in lst )
	{
		ff = fname->ToUpper();
		if( ff->StartsWith( "CV" ) && ff->EndsWith( ".DLL" ) )
		{// 
			break;
		}
		ff = nullptr;
	}
	if( ff == nullptr )		throw gcnew System::Exception( "CXg[tH_pX擾ł܂B" );

	// tpX擾
	array<wchar_t>^ ffw = ff->ToCharArray();
	pin_ptr<wchar_t> ffp = &ffw[0];
	wchar_t dllpathwk[ MAX_PATH + 1 ];
	HANDLE hProc = ::GetCurrentProcess();
	HMODULE hMod = ::GetModuleHandleW( ffp );
	GetModuleFileNameExW( hProc, hMod, dllpathwk, MAX_PATH );
	String^ dllpath = gcnew String( dllpathwk );

	// DLLpX̐epX̐epX擾ic:\aaa\...\bbb\bin\cv100.dll -> c:\aaa...\bbbj
	System::IO::DirectoryInfo^ di = System::IO::Directory::GetParent( dllpath );
	String^ wp = di->Parent->FullName;
	
	return wp;
#endif

}

#pragma endregion 

#pragma region rbg}bv֘A

///////////////////////////////////////////////////////////////
// C[Wrbg}bv𐶐܂B
static void CreateBitmap( IplImage^ Image, Bitmap^% Bmp )
{
	// `FbN
	if( Image == nullptr )	throw gcnew System::ArgumentNullException( "ɂNull/Nothingwł܂B" );
	if( Image->BasePtr->depth != IPL_DEPTH_8U )
		throw gcnew System::ArgumentException( "rbg[x IPL_DEPTH_8U łȂׁArbg}bvC[W쐬ł܂B" );
	Imaging::PixelFormat pf;
	switch( Image->BasePtr->nChannels )
	{
		case 1:	pf = Imaging::PixelFormat::Format8bppIndexed; break;
		case 3: pf = Imaging::PixelFormat::Format24bppRgb; break;
		default:
			throw gcnew System::ArgumentException( "`l 1  3 łȂׁArbg}bvC[W쐬ł܂B" );
			break;
	}

	// rbg}bv
	int sx = Image->BasePtr->width;
	int sy = Image->BasePtr->height;
	if( Bmp != nullptr )
	{// ɐĂꍇ

		// ėp\H
		if( (Bmp->Width != sx) || (Bmp->Height != sy) || (Bmp->PixelFormat != pf) )
		{// ėps

			// č쐬悤ɂ
			Bmp = nullptr;
		}
	}
	if( Bmp == nullptr )
	{// 쐬K{

		// 쐬
		Bmp = gcnew Bitmap( sx, sy, pf );
	}

	// `lP̏ꍇApbg𐶐
	if( pf == Imaging::PixelFormat::Format8bppIndexed )
	{
		// OCXP[̃pbg𐶐
		Imaging::ColorPalette^ plt = Bmp->Palette;
		for( int x = 0; x < 255; x++ )
		{
			plt->Entries[x] = Color::FromArgb( x, x, x );
		}
		Bmp->Palette = plt;
	}

	// rbg}bvf[^̓]
	System::Drawing::Rectangle rct( 0, 0, sx, sy );
	Imaging::BitmapData^ bd = Bmp->LockBits( rct, Imaging::ImageLockMode::WriteOnly, Bmp->PixelFormat );
	if( bd->Stride * bd->Height == Image->BasePtr->imageSize )
	{// ]ׂf[^ʂv

		// sNZ]
		memcpy( bd->Scan0.ToPointer(), Image->BasePtr->imageData, Image->BasePtr->imageSize );
	}
	Bmp->UnlockBits( bd );

	// rbg}bv̏㉺]
	if( Image->BasePtr->origin == IPL_ORIGIN_BL )
	{ // f[^i[{gAbv̏ꍇA㉺ւ
		Bmp->RotateFlip( RotateFlipType::RotateNoneFlipY );
	}
}

///////////////////////////////////////////////////////////////
// rbg}bvC[W𐶐܂B
static void CreateImage( Bitmap^ Bmp, IplImage^% Image )
{
	// `FbN
	if( Bmp == nullptr )	throw gcnew System::ArgumentNullException( "Null/Nothing͎wł܂B" );
	if( (Bmp->PixelFormat != Imaging::PixelFormat::Format8bppIndexed) && 
		(Bmp->PixelFormat != Imaging::PixelFormat::Format24bppRgb) ) 
				throw gcnew System::ArgumentException( "sNZtH[}bgT|[gȂ`łB(Format8bppIndexedFormat24bppRgb̂݃T|[g܂B)" );
	
	// rbg}bv擾
	int sx = Bmp->Width;
	int sy = Bmp->Height;
	int ch = 0;
	if( Bmp->PixelFormat == Imaging::PixelFormat::Format8bppIndexed )	ch = 1;
	if( Bmp->PixelFormat == Imaging::PixelFormat::Format24bppRgb )		ch = 3;

	// C[W
	if( Image != nullptr )
	{// ɍ쐬Ă

		// ėp\H
		if( (sx != Image->width) || (sy != Image->height) || (ch != Image->nChannels) )
		{// ėps

			// č쐬悤ɂ
			Image = nullptr;
		}
	}
	if( Image == nullptr )
	{// 쐬K{
		
		// 쐬
		Image = cvCreateImage( cvSize_( sx, sy ), IPL_DEPTH_8U, ch );
	}

	// rbg}bvf[^̓]
	System::Drawing::Rectangle rct( 0, 0, sx, sy );
	Imaging::BitmapData^ bd = Bmp->LockBits( rct, Imaging::ImageLockMode::ReadOnly, Bmp->PixelFormat );
	if( bd->Stride * bd->Height == Image->BasePtr->imageSize )
	{// ]ׂf[^ʂv

		// sNZ]
		memcpy( Image->BasePtr->imageData, bd->Scan0.ToPointer(), Image->BasePtr->imageSize );
	}
	Bmp->UnlockBits( bd );
}

///////////////////////////////////////////////////////////////
// \[XC[Wǂݍ݂܂B
static IplImage^ LoadImageFromResorce( Assembly^ Assem, String^ ResourceName )
{
	// \[X̌
	String^ rname = String::Concat( Assem->GetName()->Name, ".", ResourceName );

	// rbg}bvǂݍ
	System::IO::Stream^ stm = Assem->GetManifestResourceStream( rname );
	if( stm == nullptr )	throw gcnew Exception( String::Format( "\[Xt܂B- {0}", rname ) );
	Bitmap^ bmp = gcnew Bitmap( stm );
	if( bmp == nullptr )	throw gcnew Exception( String::Format( "rbg}bv\[Xǂݍ߂܂B- {0}", rname ) );

	// C[W쐬
	IplImage^ ret = nullptr;
	CreateImage( bmp, ret );

	return ret;
}

///////////////////////////////////////////////////////////////
// \[XC[Wǂݍ݂܂B
static IplImage^ LoadImageFromResorce( String^ ResourceName )
{
	// AZu擾
	Assembly^ assem = Assembly::GetCallingAssembly();

	// ǂݍ
	IplImage^ ret = LoadImageFromResorce( assem, ResourceName );

	return ret;
}

///////////////////////////////////////////////////////////////
// \[XC[Wǂݍ݂܂Bi`lwj
// iscolorCV_LOAD_IMAGE_GRAYSCALEw肳ꂽꍇAP`l摜ƂȂ܂B
// iscolorCV_LOAD_IMAGE_COLORw肳ꂽꍇAR`l摜ƂȂ܂B
// iscolorLȊȌꍇA摜ɍ킹`lƂȂ܂B
static IplImage^ LoadImageFromResorce( String^ ResourceName, int iscolor )
{
	// AZu擾
	Assembly^ assem = Assembly::GetCallingAssembly();

	// ǂݍ
	IplImage^ ret = LoadImageFromResorce( assem, ResourceName );
	if( ret == nullptr )	return nullptr;

	// `ʂ̏
	if( iscolor == CV_LOAD_IMAGE_GRAYSCALE )
	{// OCXP[w̏ꍇ
		if( ret->nChannels == 1 )
		{// `

			// ϊsv

		} else if( ret->nChannels == 3 )
		{// 摜̓J[

			// ϊ
			IplImage^ img = ret;
			ret = cvCreateImage( cvSize_( img->width, img->height), IPL_DEPTH_8U, 1 );
			cvCvtColor( img, ret, CV_BGR2GRAY );
		} else
		{// 
			throw gcnew System::ArgumentException( String::Format( "OCXP[摜ɕϊł܂B{0}", ret->nChannels ) );
		}
	}
	if( iscolor == CV_LOAD_IMAGE_COLOR )
	{// J[w̏ꍇ
		if( ret->nChannels == 3 )
		{// `

			// ϊsv

		} else if( ret->nChannels == 1 )
		{// 摜̓OCXP[

			// ϊ
			IplImage^ img = ret;
			ret = cvCreateImage( cvSize_( img->width, img->height), IPL_DEPTH_8U, 3 );
			cvCvtColor( img, ret, CV_GRAY2BGR );
		} else
		{//
			throw gcnew System::ArgumentException( String::Format( "J[摜ɕϊł܂B{0}", ret->nChannels ) );
		}
	}

	return ret;
}


#pragma endregion
